<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>exec Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249240"></a>exec Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jiri</span> <span class="surname">Kuthan</span></h3><div class="affiliation"><span class="orgname">FhG FOKUS<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3></div></div></div><div><p class="copyright">Copyright © 2003 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275654">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id249278">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248354">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248359">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248382">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248407">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248413">1.3.1. <code class="varname">setvars</code> (integer)</a></span></dt><dt><span class="section"><a href="#time_to_kill">1.3.2. 
			<code class="varname">time_to_kill</code> (integer)
		</a></span></dt><dt><span class="section"><a href="#id293530">1.3.3. <code class="varname">async</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293566">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293571">1.4.1. 
		<code class="function">exec_dset(command)</code>
		</a></span></dt><dt><span class="section"><a href="#id293632">1.4.2. 
		<code class="function">exec_msg(command)</code>
		</a></span></dt><dt><span class="section"><a href="#id293694">1.4.3. 
		<code class="function">exec_avp(command[, avplist])</code>
		</a></span></dt><dt><span class="section"><a href="#id293768">1.4.4. 
		<code class="function">exec_getenv(environment_variable[, avp])</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293834">1.5. Known Issues</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248444">Set &#8220;<span class="quote">setvars</span>&#8221; parameter</a></dt><dt>1.2. <a href="#id293514">Set &#8220;<span class="quote">time_to_kill</span>&#8221; parameter</a></dt><dt>1.3. <a href="#id293549">Set &#8220;<span class="quote">async</span>&#8221; parameter</a></dt><dt>1.4. <a href="#id293615"><code class="function">exec_dset</code> usage</a></dt><dt>1.5. <a href="#id293677"><code class="function">exec_msg</code> usage</a></dt><dt>1.6. <a href="#id293751"><code class="function">exec_avp</code> usage</a></dt><dt>1.7. <a href="#id293816"><code class="function">exec_getenv</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275654"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249278"></a>1.1. Overview</h2></div></div></div><p>
		The Exec module enables the execution of external commands from the
		OpenSIPS script. Any valid shell commands are accepted. The final input
		string is evaluated and executed using the "/bin/sh" symlink/binary.
		OpenSIPS may additionally pass a lot more information about the request
		using environment variables:
	</p><div class="itemizedlist"><ul type="disc"><li><p>
			SIP_HF_&lt;hf_name&gt; contains value of each header field in 
			request. If a header field occurred multiple times, values are 
			concatenated and comma-separated. &lt;hf_name&gt; is in capital 
			letters. Ff a header-field name occurred in compact form, 
			&lt;hf_name&gt; is canonical.
		</p></li><li><p>
			SIP_TID is transaction identifier. All request retransmissions or 
			CANCELs/ACKs associated with a previous INVITE result in the same 
			value.
		</p></li><li><p>
			SIP_DID is dialog identifier, which is the same as to-tag. 
			Initially, it is empty.
		</p></li><li><p>
			SIP_SRCIP is source <acronym class="acronym">IP</acronym> address from which request came.
		</p></li><li><p>
			SIP_ORURI is original request <acronym class="acronym">URI</acronym>.
		</p></li><li><p>
			SIP_RURI is <span class="emphasis"><em>current</em></span> request <acronym class="acronym">URI</acronym> (if 
			unchanged, equal to original).
		</p></li><li><p>
			SIP_USER is userpart of <span class="emphasis"><em>current</em></span> request <acronym class="acronym">URI</acronym>.
		</p></li><li><p>
			SIP_OUSER is userpart of original request <acronym class="acronym">URI</acronym>.
		</p></li></ul></div><p>
		NOTE: Any environment variables which are given to the exec module
		functions must be specified using the '$$' delimiter (e.g., $$SIP_OUSER),
		otherwise they will be evaluated as OpenSIPS pseudo-variables,
		throwing scripting errors.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248354"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248359"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following  modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248382"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248407"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248413"></a>1.3.1. <code class="varname">setvars</code> (integer)</h3></div></div></div><p>
		Set to 1 to enable setting all above-mentioned environment variables
		for all executed commands.
		</p><p>
		<span class="bold"><strong>WARNING: Before enabling this parameter, make sure
		your "/bin/sh" is safe from the Shellshock bash vulnerability!!! </strong></span>
		</p><p>
		<span class="emphasis"><em>
			Default value is 0 (disabled).
		</em></span>
		</p><div class="example"><a name="id248444"></a><p class="title"><b>Example 1.1. Set &#8220;<span class="quote">setvars</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("exec", "setvars", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="time_to_kill"></a>1.3.2. 
			<code class="varname">time_to_kill</code> (integer)
		</h3></div></div></div><p>
		Specifies the longest time a program is allowed to execute. If the
		time is exceeded, the program is killed.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0 (disabled).
		</em></span>
		</p><div class="example"><a name="id293514"></a><p class="title"><b>Example 1.2. Set &#8220;<span class="quote">time_to_kill</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("exec", "time_to_kill", 20)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293530"></a>1.3.3. <code class="varname">async</code> (integer)</h3></div></div></div><p>
		Turns on the asynchronous mode for the 'exec_msg' function. All commands
		will be executed by a different process and the caller will continue
		its flow, without waiting for a response.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0 (disabled).
		</em></span>
		</p><div class="example"><a name="id293549"></a><p class="title"><b>Example 1.3. Set &#8220;<span class="quote">async</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("exec", "async", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293566"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293571"></a>1.4.1. 
		<code class="function">exec_dset(command)</code>
		</h3></div></div></div><p>
		Executes an external command. The current <acronym class="acronym">R-URI</acronym> is appended to the command
		as its last parameter. The output of the command will rewrite the current R-URI.
		Multiple lines of output lead to multiple branches.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>command (string, pvar)</em></span> - command to be
			executed. It can include pseudo-variables or '$$' delimited UNIX
			environment variables
			</p></li></ul></div><p>
		WARNING: most OpenSIPS scripting variables should be quoted before being
		passed to external commands, as in: exec_avp("log-call.sh '$ct'").
		This may help avoid some unexpected behaviour
		(e.g. unwanted extra parameters, errors due to special bash characters, etc.)
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE.
		</p><div class="example"><a name="id293615"></a><p class="title"><b>Example 1.4. <code class="function">exec_dset</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_dset("ruri-changer.sh");
exec_dset("ruri-changer.sh '$ct'");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293632"></a>1.4.2. 
		<code class="function">exec_msg(command)</code>
		</h3></div></div></div><p>
		Executes an external command. The current SIP message is passed to it in
		the standard input, no command-line parameters are added and the output
		of the command is ignored.
		</p><p>
		See sip-server/modules/exec/etc/exec.cfg in the source tarball for 
		information on usage.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>command (string)</em></span> - command to be executed. It
			can include pseudo-variables or '$$' delimited UNIX
			environment variables
			</p></li></ul></div><p>
		WARNING: most OpenSIPS scripting variables should be quoted before being
		passed to external commands, as in: exec_avp("log-call.sh '$ct'").
		This may help avoid some unexpected behaviour
		(e.g. unwanted extra parameters, errors due to special bash characters, etc.)
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, LOCAL_ROUTE,
		TIMER_ROUTE, EVENT_ROUTE, ONREPLY_ROUTE.
		</p><div class="example"><a name="id293677"></a><p class="title"><b>Example 1.5. <code class="function">exec_msg</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_msg("call-logger.sh '$ct' &gt;&gt; /var/log/call-logger/'$rU'.calls");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293694"></a>1.4.3. 
		<code class="function">exec_avp(command[, avplist])</code>
		</h3></div></div></div><p>
		Executes an external command. Each output line of the command
		is saved in its corresponding AVP from <span class="emphasis"><em>avplist</em></span>.
		If <span class="emphasis"><em>avplist</em></span> is missing or is incomplete, the
		populated AVPs will be 1, 2, 3... or N, N+1, N+2...
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>command (string)</em></span> - command to be
			executed. It can include pseudo-variables or '$$' delimited UNIX
			environment variables
			</p></li><li><p><span class="emphasis"><em>avplist (string)</em></span> - comma separated list with AVP
			names to store the result in
			</p></li></ul></div><p>
		WARNING: most OpenSIPS scripting variables should be quoted before being
		passed to external commands, as in: exec_avp("log-call.sh '$ct'").
		This may help avoid some unexpected behaviour
		(e.g. unwanted extra parameters, errors due to special bash characters, etc.)
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		LOCAL_ROUTE, STARTUP_ROUTE, TIMER_ROUTE, EVENT_ROUTE, ONREPLY_ROUTE.
		</p><div class="example"><a name="id293751"></a><p class="title"><b>Example 1.6. <code class="function">exec_avp</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_avp("get-subscriber-details.sh '$rU'", "$avp(credit) $avp(contract_model)");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293768"></a>1.4.4. 
		<code class="function">exec_getenv(environment_variable[, avp])</code>
		</h3></div></div></div><p>
		Obtains the value of a UNIX evironment_variable. The value is saved
		in 'avp'. If 'avp' is missing, output will be stored in $avp(1). If there
		is no such environment variable no value will be returned.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>environment_variable (string)</em></span> -
				environent variable name. Can also be specified as a pseudo-variable
		</p></li><li><p><span class="emphasis"><em>avp</em></span> - an AVP to store the  result in
			</p></li></ul></div><p>
		WARNING: any OpenSIPS pseudo-vars which may contain special bash
		characters should be placed inside quotes, e.g. exec_getenv("'$ct'");
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		LOCAL_ROUTE, STARTUP_ROUTE, TIMER_ROUTE, EVENT_ROUTE, ONREPLY_ROUTE.
		</p><div class="example"><a name="id293816"></a><p class="title"><b>Example 1.7. <code class="function">exec_getenv</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_getenv("HOSTNAME");
exec_getenv("HOSTNAME", "$avp(localhost)");
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293834"></a>1.5. Known Issues</h2></div></div></div><p>
		When imposing an execution timeout using
		<span class="bold"><strong><a class="xref" href="#time_to_kill" title="1.3.2.  time_to_kill (integer)">time_to_kill</a></strong></span>,
		make sure your "/bin/sh" is a shell which does not fork when executed,
		case in which the job itself will not be killed, but rather its parent shell,
		while the job is silently inherited by "init" and will continue to run.
		"/bin/dash" is one of these troublesome shell environments.
	</p></div></div></div></body></html>
