<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>H350 Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248490"></a>H350 Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Christian</span> <span class="surname">Schlatter</span></h3><div class="affiliation"><span class="orgname">University of North Carolina<br></span></div><code class="email">&lt;<a class="email" href="mailto:cs@unc.edu">cs@unc.edu</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2007 University of North Carolina</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision 0.1</td><td align="left">05-17-2007</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277773">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id266894">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id248024">1.1.1. Example H.350 commObject LDAP Entry</a></span></dt></dl></dd><dt><span class="section"><a href="#id249302">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249307">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249605">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249627">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249633">1.3.1. ldap_session (string)</a></span></dt><dt><span class="section"><a href="#id248937">1.3.2. base_dn (string)</a></span></dt><dt><span class="section"><a href="#id248966">1.3.3. search_scope (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id248996">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293505">1.4.1. h350_sipuri_lookup(sip_uri)</a></span></dt><dt><span class="section"><a href="#id293670">1.4.2. h350_auth_lookup(auth_username, "username_avp_spec/pwd_avp_spec")</a></span></dt><dt><span class="section"><a href="#id248856">1.4.3. h350_result_call_preferences(avp_name_prefix)</a></span></dt><dt><span class="section"><a href="#id294255">1.4.4. h350_result_service_level(avp_name_prefix)</a></span></dt></dl></dd></dl></dd><dt><span class="bibliography"><a href="#id295537">Resources</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249274">Example H.350 commObject storing SIP account data</a></dt><dt>1.2. <a href="#id248922"><code class="varname">ldap_session</code> parameter usage</a></dt><dt>1.3. <a href="#id248951"><code class="varname">base_dn</code> parameter usage</a></dt><dt>1.4. <a href="#id248979"><code class="varname">search_scope</code> parameter usage</a></dt><dt>1.5. <a href="#id293654">Example Usage</a></dt><dt>1.6. <a href="#id293848">Example Usage</a></dt><dt>1.7. <a href="#id294031">Example H.350 callPreferenceURI simple call forwarding rules</a></dt><dt>1.8. <a href="#id294223">Example Usage</a></dt><dt>1.9. <a href="#id294293">Example SIPIdentityServiceLevel values and resulting AVPs</a></dt><dt>1.10. <a href="#id294423">Example Usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277773"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id266894"></a>1.1. Overview</h2></div></div></div><p>
			The OpenSIPS H350 module enables an OpenSIPS SIP proxy server to access SIP account data stored in an LDAP <a class="xref" href="#RFC4510" title="Lightweight Directory Access Protocol (LDAP): Technical Specification Road Map">[RFC4510]</a> directory containing H.350 <a class="xref" href="#H350" title="Directory Services Architecture for Multimedia Conferencing">[H.350]</a> <span class="emphasis"><em>commObjects</em></span>. ITU-T Recommendation H.350 standardizes LDAP object classes to store Real-Time Communication (RTC) account data. In particular, <span class="emphasis"><em>H.350.4</em></span> <a class="xref" href="#H350-4" title="Directory services architecture for SIP">[H.350.4]</a> defines an object class called <span class="emphasis"><em>sipIdentity</em></span> that includes attribute specifications for SIP account data like SIP URI, SIP digest username/password, or service level. This allows to store SIP account data in a vendor neutral way and lets different entities, like SIP proxies, provisioning, or billing applications, access the data in a standardized format.  
        </p><p>
			The <span class="emphasis"><em>ViDe H.350 Cookbook</em></span> <a class="xref" href="#vide-H350-cookbook" title="ViDe H.350 Cookbook">[vide-h.350-cb]</a>  is a good reference for deploying an H.350 directory. Besides general information on H.350, LDAP, and related standards, this document explains how to set up an H.350/LDAP directory and discusses different deployment scenarios.    
        </p><p>
            The H350 module uses the OpenSIPS LDAP module to import H.350 attribute values into the OpenSIPS routing script variable space. The module exports functions to parse and store the H.350 attribute values from the OpenSIPS routing script. It allows a script writer to implement H.350 based SIP digest authentication, call forwarding, SIP URI alias to AOR rewriting, and service level parsing. 
        </p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248024"></a>1.1.1. Example H.350 commObject LDAP Entry</h3></div></div></div><p>
            The following example shows a typical H.350 commObject LDAP entry storing SIP account data.
        </p><div class="example"><a name="id249274"></a><p class="title"><b>Example 1.1. Example H.350 commObject storing SIP account data</b></p><div class="example-contents"><pre class="programlisting">
Attribute Name                Attribute Value(s)
--------------                -----------------

# LDAP URI identifying the owner of this commObject, typically 
# points to an entry in the enterprise directory
commOwner	ldap://dir.example.com/dc=example,dc=com??one?(uid=bob)	

# Unique identifier for this commObject, used for referencing 
# this object e.g. from the enterprise directory 
commUniqueId                  298217asdjgj213	

# Determines if this commObject should be listed on white pages
commPrivate                   false

# Valid SIP URIs for this account (can be used to store alias SIP URIs 
# like DIDs as well)
SIPIdentitySIPURI             sip:bob@example.com                 
                              sip:bob@alias.example.com
                              sip:+1919123456@alias.example.com
# SIP digest username	
SIPIdentityUserName           bob

# SIP digest password
SIPIdentityPassword           pwd

# SIP proxy address
SIPIdentityProxyAddress       sip.example.com

# SIP registrar address
SIPIdentityRegistrarAddress   sip.example.com

# Call preferences: Forward to voicemail on no response 
# after 20 seconds and on busy
callPreferenceURI             sip:bob@voicemail.example.com n:20000
                              sip:bob@voicemail.example.com b
	
# Account service level(s)
SIPIdentityServiceLevel	      long_distance
                              conferencing
                              
# H.350 object classes
objectClass                   top
                              commObject
                              SIPIdentity
                              callPreferenceURIObject
            </pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249302"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249307"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>The module depends on the following modules (the listed modules
        must be loaded before this module):</p><div class="itemizedlist"><ul type="disc"><li><p>LDAP</p></li></ul></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249605"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>The following libraries or applications must be installed before
        running OpenSIPS with this module loaded:</p><div class="itemizedlist"><ul type="disc"><li><p>OpenLDAP library (libldap), libldap header files
            (libldap-dev) are needed for compilation</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249627"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249633"></a>1.3.1. ldap_session (string)</h3></div></div></div><p>
            Name of the LDAP session to be used for H.350 queries, as defined in the LDAP module configuration file.
        </p><p>
            Default value: ""
        </p><div class="example"><a name="id248922"></a><p class="title"><b>Example 1.2. <code class="varname">ldap_session</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("h350", "ldap_session", "h350");
            </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248937"></a>1.3.2. base_dn (string)</h3></div></div></div><p>
            Base LDAP DN to start LDAP search for H.350 entries. For best performance, this should be set to the direct ancestor of the H.350 objects.
        </p><p>
            Default value: ""
        </p><div class="example"><a name="id248951"></a><p class="title"><b>Example 1.3. <code class="varname">base_dn</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("h350", "base_dn", "ou=h350,dc=example,dc=com");
            </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248966"></a>1.3.3. search_scope (string)</h3></div></div></div><p>
            LDAP search scope for H.350 queries, one of "one", "base", or "sub".
        </p><p>
            Default value: "one"
        </p><div class="example"><a name="id248979"></a><p class="title"><b>Example 1.4. <code class="varname">search_scope</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("h350", "search_scope", "sub");
            </pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248996"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293505"></a>1.4.1. h350_sipuri_lookup(sip_uri)</h3></div></div></div><p>
            This function performs an LDAP search query for an H.350 commObject with a SIPIdentitySIPURI of <code class="varname">sip_uri</code>. The <code class="varname">sip_uri</code> parameter first gets escaped according the rules for LDAP filter strings. The result of the LDAP search is stored internally and can be accessed either by one of the <span class="emphasis"><em>h350_result*</em></span> or one of the <span class="emphasis"><em>ldap_result*</em></span> functions from the OpenSIPS LDAP module.
        </p><p>
            The function returns <code class="varname">-1</code> (FALSE) for internal errors, and <code class="varname">-2</code> (FALSE) if no H.350 commObject was found with a matching <code class="varname">sip_uri</code>. <code class="varname">n</code> &gt; 0 (TRUE) is returned if <code class="varname">n</code> H.350 commObjects were found.
        </p><p>
            This function can be used from REQUEST_ROUTE, ONREPLY_ROUTE, FAILURE_ROUTE and BRANCH_ROUTE.
        </p><div class="variablelist"><p class="title"><b>Function Parameters:</b></p><dl><dt><span class="term">sip_uri</span></dt><dd><p>
                        H.350 SIPIdentitySIPURI to search for in directory. Included OpenSIPS variables do get expanded.
                    </p></dd></dl></div><div class="variablelist"><p class="title"><b>Return Values:</b></p><dl><dt><span class="term"><code class="varname">n</code> &gt; 0 (TRUE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                <code class="varname">n</code> H.350 commObjects found.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-1</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                Internal error occurred.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-2</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                No H.350 commObject found.
                            </p></li></ul></div></dd></dl></div><p>
        This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, BRANCH_ROUTE, and ONREPLY_ROUTE.
        </p><div class="example"><a name="id293654"></a><p class="title"><b>Example 1.5. Example Usage</b></p><div class="example-contents"><pre class="programlisting">
#
# H.350 lookup for callee
#

if (!h350_sipuri_lookup("sip:$rU@$rd"))
{
    switch ($retcode)
    {
    case -2:
        xlog("L_INFO", 
             "h350 callee lookup: no entry found in H.350 directory");
        exit;
    case -1:
        sl_send_reply("500", "Internal server error");
        exit;
    }
}

# now h350_result* or ldap_result* functions can be used
            </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293670"></a>1.4.2. h350_auth_lookup(auth_username, "username_avp_spec/pwd_avp_spec")</h3></div></div></div><p>
            This function performs an LDAP search query for SIP digest authentication credentials in an H.350 directory. The H.350 directory is searched for a commObject with SIPIdentityUserName of <code class="varname">auth_username</code>. If such a commObject is found, the SIP digest authentication username and password are stored in AVPs <code class="varname">username_avp_spec</code> and <code class="varname">pwd_avp_spec</code>, respectively. <span class="emphasis"><em>pv_*_authorize</em></span> functions from AUTH module can then be used to perform SIP digest authentication.
        </p><p>
            The function returns <code class="constant">1</code> (TRUE) if an H.350 commObject was found, <code class="constant">-1</code> (FALSE) in case of an internal error, and <code class="constant">-2</code> (FALSE) if no matching commObject was found.
        </p><p>
            This function can be used from REQUEST_ROUTE, ONREPLY_ROUTE, FAILURE_ROUTE and BRANCH_ROUTE.
        </p><div class="variablelist"><p class="title"><b>Function Parameters:</b></p><dl><dt><span class="term">auth_username</span></dt><dd><p>
                        H.350 SIPIdentityUserName to search for in directory. Included OpenSIPS variables do get expanded.
                    </p></dd><dt><span class="term">username_avp_spec</span></dt><dd><p>
                        Specification for authentication username AVP, e.g. <code class="varname">$avp(username)</code>.
                    </p></dd><dt><span class="term">pwd_avp_spec</span></dt><dd><p>
                        Specification for authentication password AVP, e.g. <code class="varname">$avp(pwd)</code>.
                    </p></dd></dl></div><div class="variablelist"><p class="title"><b>Return Values:</b></p><dl><dt><span class="term"><code class="constant">1</code> (TRUE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                H.350 commObject found and SIP digest authentication credentials stored in <code class="varname">username_avp_spec</code> and <code class="varname">pwd_avp_spec</code>.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-1</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                Internal error occurred.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-2</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                No H.350 commObject found.
                            </p></li></ul></div></dd></dl></div><p>
        This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, BRANCH_ROUTE, and ONREPLY_ROUTE.
        </p><div class="example"><a name="id293848"></a><p class="title"><b>Example 1.6. Example Usage</b></p><div class="example-contents"><pre class="programlisting">
# -- auth params --
modparam("auth", "username_spec", "$avp(auth_user)")
modparam("auth", "password_spec", "$avp(auth_pwd)")
modparam("auth", "calculate_ha1", 1)

# -- h350 params --
modparam("h350", "ldap_session", "h350")
modparam("h350", "base_dn", "ou=h350,dc=example,dc=com")
modparam("h350", "search_scope", "one")


route[1]
{
    #
    # H.350 based SIP digest authentication 
    #
     
    # challenge all requests not including an Auth header
    if (!(is_present_hf("Authorization") || 
          is_present_hf("Proxy-Authorization")))
    {
        if (is_method("REGISTER"))
        {
            www_challenge("example.com", "0");
            exit;
        }
        proxy_challenge("example.com", "0");
        exit;
    }

    # get digest password from H.350 using auth username ($au)
    if (!h350_auth_lookup("$au", 
                          "$avp(auth_user)/$avp(auth_pwd)"))
    {
        switch ($retcode)
        {
        case -2:
            sl_send_reply("401", "Unauthorized");
            exit;
        case -1:
            sl_send_reply("500", "Internal server error");
            exit;
        }
    }

    # REGISTER requests
    if (is_method("REGISTER"))
    {
        if (!pv_www_authorize("example.com"))
        {
            if ($retcode == -5)
            {
                sl_send_reply("500", "Internal server error");
                exit;    
            }
            else {
                www_challenge("example.com", "0");
                exit;
            }
        }

        consume_credentials();
        xlog("L_INFO", 
             "REGISTER request successfully authenticated");
        return(1);
    }

    # non-REGISTER requests
    if (!pv_proxy_authorize("example.com"))
    {
        if ($retcode == -5)
        {
            sl_send_reply("500", "Internal server error");
            exit;    
        }
        else {
            proxy_challenge("example.com", "0");
            exit;
        }
    }

    consume_credentials();
    xlog("L_INFO", "$rm request successfully authenticated");
    return(1);
}
            </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248856"></a>1.4.3. h350_result_call_preferences(avp_name_prefix)</h3></div></div></div><p>
			This function parses the callPreferenceURI attribute of an H.350 commObject, which must have been fetched through <span class="emphasis"><em>h350_*_lookup</em></span> or <span class="emphasis"><em>ldap_search</em></span>. callPreferenceURI is a multi-valued attribute that stores call preference rules like e.g. forward-on-busy or forward-unconditionally. <span class="emphasis"><em>Directory services architecture for call forwarding and preferences</em></span> <a class="xref" href="#H350-6" title="Directory services architecture for call forwarding and preferences">[H.350.6]</a> defines a format for simple call forwarding rules:
        </p><div class="blockquote"><blockquote class="blockquote"><p>
                <code class="literal">target_uri type[:argument]</code>
            </p></blockquote></div><p>
            In a SIP environment, <code class="literal">target_uri</code> is typically the call forwarding rule's target SIP URI, although it could be any type of URI, e.g. an HTTP pointer to a CPL script. Four different values are specified for <code class="literal">type</code>: <code class="literal">b</code> for "forward on busy", <code class="literal">n</code> for "forward on no answer", <code class="literal">u</code> for "forward unconditionally", and <code class="literal">f</code> for "forward on destination not found". The optional <code class="literal">argument</code> is a string indicating the time in milliseconds after which the call forwarding should occur.
        </p><div class="example"><a name="id294031"></a><p class="title"><b>Example 1.7. Example H.350 callPreferenceURI simple call forwarding rules</b></p><div class="example-contents"><pre class="programlisting">

# Example 1:
# forward to sip:voicemail@example.com on no answer after 15 seconds:

callPreferenceURI: sip:voicemail@example.com n:15000

# Example 2:
# unconditionally forward to sip:alice@example.com:

callPreferenceURI: sip:alice@example.com u

# Example 3:
# forward to sip:bob@example.com and sip:alice@example.com
# (forking) on destination not found:

callPreferenceURI: sip:bob@example.com f
callPreferenceURI: sip:alice@example.com f
            </pre></div></div><br class="example-break"><p>
            <span class="emphasis"><em>h350_result_call_preferences</em></span> stores these call forwarding rules as AVPs according to the following rules:
        </p><div class="blockquote"><blockquote class="blockquote"><pre class="programlisting">
#
# AVP storing a forwarding rule's target URI
#
            
AVP name  = avp_name_prefix + '_' + type
AVP value = target_uri

#
# AVP storing a forwarding rule's argument
#

AVP name  = avp_name_prefix + '_' + type + '_t'
AVP value = argument / 1000
            </pre></blockquote></div><p>
            Example 1 from above would result in two AVPs: <code class="literal">$avp("prefix_n") = "sip:voicemail@example.com"</code> and <code class="literal">$avp("prefix_n_t") = 15</code>.
        </p><p>
            Example 2: <code class="literal">$avp("prefix_u") = "sip:alice@example.com"</code>.
        </p><p>
            Example 3: <code class="literal">$avp("prefix_f[1]") = "sip:bob@example.com"</code> and <code class="literal">$avp("prefix_f[2]]") = "sip:alice@example.com"</code>.
        </p><p>
            These AVPs can then be used to implement the desired behavior in the OpenSIPS routing script.
        </p><p>
            This function returns the number of successfully parsed simple call forwarding rules (TRUE), in case the H.350 callPreferenceURI attribute contained one or multiple values matching the simple call forwarding rule syntax described above. It returns <code class="constant">-1</code> (FALSE) for internal errors, and <code class="constant">-2</code> (FALSE) if none of the rules matched or if no callPreferenceURI attribute was found.
        </p><p>
            This function can be used from REQUEST_ROUTE, ONREPLY_ROUTE, FAILURE_ROUTE and BRANCH_ROUTE.
        </p><div class="variablelist"><p class="title"><b>Function Parameters:</b></p><dl><dt><span class="term">avp_name_prefix</span></dt><dd><p>
                        Name prefix for call forwarding rule AVPs, as described above.
                    </p></dd></dl></div><div class="variablelist"><p class="title"><b>Return Values:</b></p><dl><dt><span class="term"><code class="varname">n</code> &gt; 0 (TRUE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                <code class="varname">n</code> simple call forwarding rules found.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-1</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                Internal error occurred.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-2</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                No simple call forwarding rule found, or callPreferenceURI not present.
                            </p></li></ul></div></dd></dl></div><p>
        This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, BRANCH_ROUTE, and ONREPLY_ROUTE.
        </p><div class="example"><a name="id294223"></a><p class="title"><b>Example 1.8. Example Usage</b></p><div class="example-contents"><pre class="programlisting">
#
# H.350 lookup for callee
#

... h350_sipuri_lookup("sip:$rU@$rd") ...

#
# store H.350 call preferences in AVP
#

if (!h350_result_call_preferences("callee_pref_") &amp;&amp; ($retcode == -1))
{
    sl_send_reply("500", "Internal server error");
    exit;
}

# $avp(callee_pref_u)   == CFU URI(s)
# $avp(callee_pref_n)   == CFNR URI(s)
# $avp(callee_pref_n_t) == CFNR timeout in seconds
# $avp(callee_pref_b)   == CFB URI(s)
# $avp(callee_pref_f)   == CFOFFLINE URI(s)

#
# Example for forward-unconditionally (CFU)
#

if (is_avp_set("$avp(callee_pref_u)"))
{
    # replace R-URI with CFU URI, g will fetch all CFU URIs 
    # --&gt; request can fork
    if (avp_pushto("$ru", "$avp(callee_pref_u)/g"))
    {
            avp_delete("$avp(callee_pref_u)");
    } else
    {
            sl_send_reply("500", "Internal server error");
            exit;
    }
    sl_send_reply("181", "Call is being forwarded");
    t_relay();
    exit;
}
            </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294255"></a>1.4.4. h350_result_service_level(avp_name_prefix)</h3></div></div></div><p>
			<span class="emphasis"><em>Directory services architecture for SIP</em></span> <a class="xref" href="#H350-4" title="Directory services architecture for SIP">[H.350.4]</a> defines a multi-valued LDAP attribute named SIPIdentityServiceLevel, which can be used to store SIP account service level values in an LDAP directory. This function parses the SIPIdentityServiceLevel attribute and stores all service level values as AVPs for later retrieval in the OpenSIPS routing script. The function accesses the H.350 commObject fetched by a call to <span class="emphasis"><em>h350_*_lookup</em></span> or <span class="emphasis"><em>ldap_search</em></span>. 
        </p><p>
            The resulting AVPs have a name of the form <code class="literal">avp_name_prefix + SIPIdentityServiceLevel attribute value</code>, and an integer value of <code class="constant">1</code>. 
        </p><div class="example"><a name="id294293"></a><p class="title"><b>Example 1.9. Example SIPIdentityServiceLevel values and resulting AVPs</b></p><div class="example-contents"><pre class="programlisting">
SIPIdentityServiceLevel: longdistance
SIPIdentityServiceLevel: international
SIPIdentityServiceLevel: 900

after calling h350_result_service_level("sl_"), the following AVPs 
will be available in the routing script:

$avp("sl_longdistance") = 1
$avp("sl_international") = 1
$avp("sl_900") = 1
            </pre></div></div><br class="example-break"><p>
            This function returns the number of added AVPs (TRUE), <code class="constant">-1</code> (FALSE)for internal errors, and <code class="constant">-2</code> (FALSE)if no SIPIdentityServiceLevel attribute was found.
        </p><p>
            The function can be used from REQUEST_ROUTE, ONREPLY_ROUTE, FAILURE_ROUTE and BRANCH_ROUTE.
        </p><div class="variablelist"><p class="title"><b>Function Parameters:</b></p><dl><dt><span class="term">avp_name_prefix</span></dt><dd><p>
                        Name prefix for service level AVPs, as described above.
                    </p></dd></dl></div><div class="variablelist"><p class="title"><b>Return Values:</b></p><dl><dt><span class="term"><code class="varname">n</code> &gt; 0 (TRUE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                <code class="varname">n</code> AVPs added.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-1</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                Internal error occurred.
                            </p></li></ul></div></dd><dt><span class="term"><code class="constant">-2</code> (FALSE):</span></dt><dd><div class="itemizedlist"><ul type="disc"><li><p>
                                No SIPIdentityServiceLevel attribute found.
                            </p></li></ul></div></dd></dl></div><p>
        This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, BRANCH_ROUTE, and ONREPLY_ROUTE.
        </p><div class="example"><a name="id294423"></a><p class="title"><b>Example 1.10. Example Usage</b></p><div class="example-contents"><pre class="programlisting">
#
# H.350 SIP digest authentication for caller
#

... h350_auth_lookup("$au", ...) ...

#
# store caller's service level as AVP
#

if (!h350_result_service_level("caller_sl_") &amp;&amp; ($retcode == -1))
{
    sl_send_reply("500", "Internal server error");
    exit;
}

#
# make routing decision based on service level AVPs
#

if (is_avp_set("$avp(caller_sl_international)"))
{
    t_relay();
} 
else {
    sl_send_reply("403", "Forbidden");    
}
exit;
            </pre></div></div><br class="example-break"></div></div></div><div class="bibliography"><div class="titlepage"><div><div><h2 class="title"><a name="id295537"></a>Resources</h2></div></div></div><div class="bibliodiv"><div class="biblioentry"><a name="H350"></a><p>[<abbr class="abbrev">H.350</abbr>] <span class="title"><i><a class="ulink" href="http://www.itu.int/rec/T-REC-H.350/en" target="_top">Directory
        Services Architecture for Multimedia Conferencing</a></i>. </span><span class="date">August 2003. </span><span class="publisher"><span class="publishername">ITU-T. </span></span></p></div><div class="biblioentry"><a name="H350-4"></a><p>[<abbr class="abbrev">H.350.4</abbr>] <span class="title"><i><a class="ulink" href="http://www.itu.int/rec/T-REC-H.350.4/en" target="_top">Directory
        services architecture for SIP</a></i>. </span><span class="date">August 2003. </span><span class="publisher"><span class="publishername">ITU-T. </span></span></p></div><div class="biblioentry"><a name="H350-6"></a><p>[<abbr class="abbrev">H.350.6</abbr>] <span class="title"><i><a class="ulink" href="http://www.itu.int/rec/T-REC-H.350.6/en" target="_top">Directory services architecture for call forwarding and preferences</a></i>. </span><span class="date">March 2004. </span><span class="publisher"><span class="publishername">ITU-T. </span></span></p></div><div class="biblioentry"><a name="vide-H350-cookbook"></a><p>[<abbr class="abbrev">ViDe-H.350-Cookbook</abbr>] <span class="title"><i><a class="ulink" href="http://www.vide.net/cookbookh350/" target="_top">ViDe H.350 Cookbook</a></i>. </span><span class="date">2005. </span><span class="publisher"><span class="publishername">ViDe. </span></span></p></div><div class="biblioentry"><a name="RFC4510"></a><p>[<abbr class="abbrev">RFC4510</abbr>] <span class="title"><i><a class="ulink" href="http://tools.ietf.org/html/rfc4510" target="_top">Lightweight
        Directory Access Protocol (LDAP): Technical Specification Road
        Map</a></i>. </span><span class="date">June 2006. </span><span class="publisher"><span class="publishername">Internet Engineering Task Force. </span></span></p></div></div></div></div></body></html>
