<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>pi_http Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284029"></a>pi_http Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3></div></div></div><div><p class="copyright">Copyright © 2012-2013 
		<a class="ulink" href="http://www.voipembedded.com" target="_top">VoIP Embedded, Inc.</a>
	    </p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Rev: 8688 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275663">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id264086">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249057">1.2. Usage</a></span></dt><dt><span class="section"><a href="#id248006">1.3. Framework</a></span></dt><dd><dl><dt><span class="section"><a href="#id248032">1.3.1. Database connection definition block</a></span></dt><dt><span class="section"><a href="#id249625">1.3.2. Table definition block</a></span></dt><dt><span class="section"><a href="#id293408">1.3.3. Command definition block</a></span></dt></dl></dd><dt><span class="section"><a href="#id293530">1.4. To-do</a></span></dt><dt><span class="section"><a href="#id293547">1.5. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id293553">1.5.1. OpenSIPS Modules</a></span></dt></dl></dd><dt><span class="section"><a href="#id293577">1.6. External Libraries or Applications</a></span></dt><dt><span class="section"><a href="#id293599">1.7. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293604">1.7.1. <code class="varname">pi_http_root</code>(string)</a></span></dt><dt><span class="section"><a href="#id293639">1.7.2. <code class="varname">framework</code>(string)</a></span></dt><dt><span class="section"><a href="#id293673">1.7.3. <code class="varname">pi_http_method</code>(integrer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293719">1.8. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293724">1.8.1. <code class="varname">pi_reload_tbls_and_cmds</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id293622">Set <code class="varname">pi_http_root</code> parameter</a></dt><dt>1.2. <a href="#id293657">Set <code class="varname">framework</code> parameter</a></dt><dt>1.3. <a href="#id293702">Set <code class="varname">pi_http_method</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275663"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id264086"></a>1.1. Overview</h2></div></div></div><p>
		This module provides an HTTP provisioning interface
		for OpenSIPS.  It is using the OpenSIPS's internal
		database API to provide a simple way of manipulating
		records inside OpenSIPS's tables.
	</p><p>
		The module offers:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			ability to connect to multiple/different databases through OpenSIPS's db API;
			(all OpenSIPS's databases are supported);
			</p></li><li><p>
			ability to perform data input validation through OpenSIPS API;
			</p></li><li><p>
			ability to reconfigure the interface layout on the fly by
			reloading the config from the xml framework via mi command interface.
			</p></li></ul></div><p>
	</p><p>
	</p><p>
		Note: when provisioning tables using <span class="emphasis"><em>db_text</em></span>,
		any change made to a <span class="emphasis"><em>db_text</em></span> table will not
		be reflected on the actual text file.  In order to force a write
		out to the disk of the cached tables, the db_text mi command
		<span class="emphasis"><em>dbt_dump</em></span> must be used.
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249057"></a>1.2. Usage</h2></div></div></div><p>
		The layout of the provisionning interface is controlled via an external
		xml file (see the framework parameter).
		An example of a framework xml file is provided inside the examples
		directory of the pi_http module.
		A simple framework file can be generated by the opensipsdbctl command:
		</p><pre class="programlisting">
opensipsdbctl pframework create
		</pre><p>
		The generated framework will be saved inside OpenSIPS's config
		directory as pi_framework_sample. The list of configurable tables will
		be based on the STANDARD_MODULES and EXTRA_MODULES vars from opensipsctlrc
		file.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248006"></a>1.3. Framework</h2></div></div></div><p>
		The xml framework file is organized in three distinctive blocks:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			database connection definition block
			</p></li><li><p>
			table definition block
			</p></li><li><p>
			command definition block
			</p></li></ul></div><p>
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248032"></a>1.3.1. Database connection definition block</h3></div></div></div><p>
		Each connection to a particular database must be defined here
		with a unique database connection id.
		The connection parameters are defined following the db_url param pattern
		for all OpenSIPS modules that are using a database.
	</p><p>
		Supported databases:
		</p><div class="itemizedlist"><ul type="disc"><li><p>berkeley</p></li><li><p>flatstore</p></li><li><p>http</p></li><li><p>mysql</p></li><li><p>oracle</p></li><li><p>postgres</p></li><li><p>text</p></li><li><p>unixodbc</p></li><li><p>virtual</p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249625"></a>1.3.2. Table definition block</h3></div></div></div><p>
		Each table managed through the  OpenSIPS provisioning interface
		must be defined here with a unique table id.
		For each table, the database connection id must be specified.
		Each table must list all columns that will be managed by the
		OpenSIPS provisioning interface.
		Each column must have a unique field name and a type.
		Each column may have a validation tag for validating input data.
	</p><p>
		Supported column types:
		</p><div class="itemizedlist"><ul type="disc"><li><p>DB_INT</p></li><li><p>DB_BIGINT</p></li><li><p>DB_DOUBLE</p></li><li><p>DB_STRING</p></li><li><p>DB_STR</p></li><li><p>DB_DATETIME</p><div class="itemizedlist"><ul type="circle"><li><p>Note: input field must be provided in
					'YEAR-MM-DD HH:MM:SS' format.</p></li></ul></div></li><li><p>DB_BLOB</p></li><li><p>DB_BITMAP</p></li></ul></div><p>
	</p><p>
		Supported validation methods:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			IPV4 - represents an IPv4 address
			</p></li><li><p>
			URI - represents a SIP URI
			</p></li><li><p>
			URI_IPV4HOST - represents a SIP URI with an IPV4 as a host
			</p></li><li><p>
			P_HOST_PORT - represents [proto:]host[:port]
			</p></li><li><p>
			P_IPV4_PORT - represents [proto:]IPv4[:port]
			</p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293408"></a>1.3.3. Command definition block</h3></div></div></div><p>
		Multiple provisioning commands can be grouped together.
		Each group can have multiple commands.
		Each command definition in a group must have the table id
		of the table that is operating on along with the command
		type to be performed.
	</p><p>
		The command type can have up to three type of column parameters:
		</p><div class="itemizedlist"><ul type="disc"><li><p>clause columns</p></li><li><p>query columns</p></li><li><p>order by columns</p></li></ul></div><p>
		Each column parameter must define the name(s) of the column(s)
		(must match a field name in the description table identified
		by the table id).
		A column can accept a list of imposed values.
		Each imposed value will have an id that will be displayed
		on the web interface and the actual value that will be
		used for db operations.
		Clause columns must define operators.
		Here's the list of supported operators:
		'&lt;', '&gt;', '=', '&lt;=', '&gt;=', '!='.
	</p><p>
		Supported database command types:
		</p><div class="itemizedlist"><ul type="disc"><li><p>DB_QUERY - performs an SQL query
			and supports three type of columns:</p><div class="itemizedlist"><ul type="circle"><li><p>clause: 0 or more columns</p></li><li><p>query: 1 column</p></li><li><p>order: 0 or 1 column</p></li></ul></div></li><li><p>DB_INSERT - performs an SQL insert
			and supports one type of column:</p><div class="itemizedlist"><ul type="circle"><li><p>query: 1 or more columns</p></li></ul></div></li><li><p>DB_DELETE - performs an SQL delete
			and supports one type of column:</p><div class="itemizedlist"><ul type="circle"><li><p>clause: 1 or more columns</p></li></ul></div></li><li><p>DB_UPDATE - performs an SQL update
			and supports two type of columns:</p><div class="itemizedlist"><ul type="circle"><li><p>clause: 0 or more columns</p></li><li><p>query: 1 or more columns</p></li></ul></div></li><li><p>DB_REPLACE - performs an SQL replace
			and supports one type of column:</p><div class="itemizedlist"><ul type="circle"><li><p>query: 1 or more columns</p></li></ul></div></li></ul></div><p>
		Please note that some databases have a restricted
		set of database command types.
	</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293530"></a>1.4. To-do</h2></div></div></div><p>
		Features to be added in the future:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			full subscriber provisionning with automatic ha1/ha1b fields.
			</p></li></ul></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293547"></a>1.5. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293553"></a>1.5.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>httpd</em></span> module.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293577"></a>1.6. External Libraries or Applications</h2></div></div></div><p>
		The following libraries or applications must be installed before
		running OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>libxml2</em></span></p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293599"></a>1.7. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293604"></a>1.7.1. <code class="varname">pi_http_root</code>(string)</h3></div></div></div><p>
		Specifies the root path for pi HTTP requests.
		The link to the OpenSIPS provisioning web interface must be constructed
		using the following patern:
		http://[opensips_IP]:[opensips_mi_port]/[pi_http_root]
		</p><p>
		<span class="emphasis"><em>The default value is "pi".</em></span>
		</p><div class="example"><a name="id293622"></a><p class="title"><b>Example 1.1. Set <code class="varname">pi_http_root</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pi_http", "pi_http_root", "opensips_pi")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293639"></a>1.7.2. <code class="varname">framework</code>(string)</h3></div></div></div><p>
		Specifies the full path for xml framework descriptor.
		</p><p>
		<span class="emphasis"><em>There's no default value. This parameter is mandatory.</em></span>
		</p><div class="example"><a name="id293657"></a><p class="title"><b>Example 1.2. Set <code class="varname">framework</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pi_http", "framework", "/usr/local/etc/opensips/pi_framework.xml")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293673"></a>1.7.3. <code class="varname">pi_http_method</code>(integrer)</h3></div></div></div><p>
		Specifies the HTTP request method to be used:
		</p><div class="itemizedlist"><ul type="disc"><li><p>0 - use GET HTTP request</p></li><li><p>1 - use POST HTTP request</p></li></ul></div><p>
		</p><p>
		<span class="emphasis"><em>The default value is 0.</em></span>
		</p><div class="example"><a name="id293702"></a><p class="title"><b>Example 1.3. Set <code class="varname">pi_http_method</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pi_http", "pi_http_method", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293719"></a>1.8. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293724"></a>1.8.1. <code class="varname">pi_reload_tbls_and_cmds</code></h3></div></div></div><p>
		Reloads the layout of the provisioning interface from the framework file.
		</p><p>
		Name: <span class="emphasis"><em>pi_reload_tbls_and_cmds</em></span>
		</p><p>Parameters: none</p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
:pi_reload_tbls_and_cmds:_reply_fifo_file_
_empty_line_
		</pre></div></div></div></div></body></html>
