<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>rest_client Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>rest_client Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div><code class="email">&lt;<a class="email" href="mailto:liviu@opensips.org">liviu@opensips.org</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision$</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id267434">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#sec-overview">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id281641">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id268444">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248791">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248011">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248017">1.3.1. <code class="varname">connection_timeout</code> (integer)</a></span></dt><dt><span class="section"><a href="#id249608">1.3.2. <code class="varname">curl_timeout</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248869">1.3.3. <code class="varname">ssl_verifypeer</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248908">1.3.4. <code class="varname">ssl_verifyhost</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293504">1.3.5. <code class="varname">ssl_capath</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293531">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293536">1.4.1. 
		<code class="function">rest_get(url, body_pv[, ctype_pv[, retcode_pv]])
		</code>
		</a></span></dt><dt><span class="section"><a href="#id293624">1.4.2. 
		<code class="function">rest_post(url, send_body_pv, send_ctype_pv,
				recv_body_pv[, recv_ctype_pv[, retcode_pv]])
		</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249591">Setting the <code class="varname">connection_timeout</code> parameter</a></dt><dt>1.2. <a href="#id249629">Setting the <code class="varname">curl_timeout</code> parameter</a></dt><dt>1.3. <a href="#id248892">Setting the <code class="varname">ssl_verifypeer</code> parameter</a></dt><dt>1.4. <a href="#id248930">Setting the <code class="varname">ssl_verifyhost</code> parameter</a></dt><dt>1.5. <a href="#id293514">Setting the <code class="varname">ssl_capath</code> parameter</a></dt><dt>1.6. <a href="#id293605"><code class="function">rest_get</code> usage</a></dt><dt>1.7. <a href="#id293695"><code class="function">rest_post</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id267434"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="sec-overview"></a>1.1. Overview</h2></div></div></div><p>
	The <span class="emphasis"><em>rest_client</em></span> module provides a means of interacting
	with an HTTP server by doing RESTful queries, such as GET and POST. 
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id281641"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id268444"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules.</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248791"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libcurl</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248011"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248017"></a>1.3.1. <code class="varname">connection_timeout</code> (integer)</h3></div></div></div><p>
		Maximum time allowed to establish a connection with the server.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">20</span>&#8221; seconds.
		</em></span>
		</p><div class="example"><a name="id249591"></a><p class="title"><b>Example 1.1. Setting the <code class="varname">connection_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("rest_client", "connection_timeout", 300)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249608"></a>1.3.2. <code class="varname">curl_timeout</code> (integer)</h3></div></div></div><p>
		Maximum time allowed for the libcurl transfer to complete.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">20</span>&#8221; seconds.
		</em></span>
		</p><div class="example"><a name="id249629"></a><p class="title"><b>Example 1.2. Setting the <code class="varname">curl_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("rest_client", "curl_timeout", 300)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248869"></a>1.3.3. <code class="varname">ssl_verifypeer</code> (integer)</h3></div></div></div><p>
		Set this to 0 in order to disable the verification of the remote peer's
		certificate. Verification is done using a default bundle of CA certificates
		which come with libcurl.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">1</span>&#8221; (enabled).
		</em></span>
		</p><div class="example"><a name="id248892"></a><p class="title"><b>Example 1.3. Setting the <code class="varname">ssl_verifypeer</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("rest_client", "ssl_verifypeer", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248908"></a>1.3.4. <code class="varname">ssl_verifyhost</code> (integer)</h3></div></div></div><p>
		Set this to 0 in order to disable the verification that the remote peer
		actually corresponds to the server listed in the certificate.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">1</span>&#8221; (enabled).
		</em></span>
		</p><div class="example"><a name="id248930"></a><p class="title"><b>Example 1.4. Setting the <code class="varname">ssl_verifyhost</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("rest_client", "ssl_verifyhost", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293504"></a>1.3.5. <code class="varname">ssl_capath</code> (integer)</h3></div></div></div><p>
		An optional path for CA certificates to be used for host verifications.
		</p><div class="example"><a name="id293514"></a><p class="title"><b>Example 1.5. Setting the <code class="varname">ssl_capath</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("rest_client", "ssl_capath", "/home/opensips/ca_certificates")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293531"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293536"></a>1.4.1. 
		<code class="function">rest_get(url, body_pv[, ctype_pv[, retcode_pv]])
		</code>
		</h3></div></div></div><p>
		Issues an HTTP GET request to the given 'url', and returns a representation
		of the resource.
		</p><p>
		The <span class="emphasis"><em>body_pv</em></span> pseudo-var will hold the body of the HTTP
		response.
		</p><p>
		The optional <span class="emphasis"><em>ctype_pv</em></span> pseudo-var will contain the value
		of the "Content-Type:" header.
		</p><p>
		The optional <span class="emphasis"><em>retcode_pv</em></span> pseudo-var is used to retain the
		HTTP status code of the response message.
		</p><p>Possible parameter types</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>url</em></span> - String, pseudo-variable, or a String
				which includes pseudo-variables. (useful for specifying additional
				attribute-value fields in the URL)
			</p></li><li><p><span class="emphasis"><em>body_pv, ctype_pv, retcode_pv</em></span> -
			pseudo-variables</p></li></ul></div><p>
		This function can be used from the <span class="emphasis"><em>startup, branch, failure,
				request</em></span> and <span class="emphasis"><em>timer</em></span> routes.
		</p><div class="example"><a name="id293605"></a><p class="title"><b>Example 1.6. <code class="function">rest_get</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Example of querying a REST service to get the credit of an account

if (!rest_get("http://getcredit.org/?ruri=$fU", "$var(credit)", "$var(ct)", "$var(rcode)")) {
	xlog("Error code $var(rcode) in HTTP GET!\n");
	send_reply("403", "Not registered");
	exit;
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293624"></a>1.4.2. 
		<code class="function">rest_post(url, send_body_pv, send_ctype_pv,
				recv_body_pv[, recv_ctype_pv[, retcode_pv]])
		</code>
		</h3></div></div></div><p>
		Issues an HTTP POST request to the specified 'url'. The request body will
		be copied from the 'send_body_pv' pseudo-variable. Its MIME content type
		will be taken from 'send_ctype_pv'.
		</p><p>
		The <span class="emphasis"><em>recv_body_pv</em></span> pseudo-var will hold the body of the HTTP
		response.
		</p><p>
		The optional <span class="emphasis"><em>recv_ctype_pv</em></span> parameter will contain
		the value of the "Content-Type:" header of the response message.
		</p><p>
		The optional <span class="emphasis"><em>retcode_pv</em></span> pseudo-var parameter can be given
		in order to save the HTTP status code of the response message.
		</p><p>Possible parameter types</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>url, send_body_pv, send_type_pv</em></span> -
			String, pseudo-variable, or a String which includes pseudo-variables.
			</p></li><li><p><span class="emphasis"><em>recv_body_pv, recv_ctype_pv, retcode_pv</em></span> -
			pseudo-variables</p></li></ul></div><p>
		This function can be used from the <span class="emphasis"><em>startup, branch, failure,
				request</em></span> and <span class="emphasis"><em>timer</em></span> routes.
		</p><div class="example"><a name="id293695"></a><p class="title"><b>Example 1.7. <code class="function">rest_post</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Storing data using a RESTful service with an HTTP POST request

if (!rest_post("http://myserver.org/register_user", "$fU", "text/plain", "$var(body)", "$var(ct)", "$var(rcode)")) {
	xlog("Error code $var(rcode) in HTTP POST!\n");
	send_reply("403", "POST Forbidden");
	exit;
}
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
