<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>SST Module (SIP Session Timer)</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249240"></a>SST Module (SIP Session Timer)</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ron</span> <span class="surname">Winacott</span></h3><div class="affiliation"><span class="orgname">SOMA Networks, Inc.<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ron</span> <span class="surname">Winacott</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 SOMA Networks, Inc.</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id248920">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id249294">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248895">1.2. How it works</a></span></dt><dt><span class="section"><a href="#id248025">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248031">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248373">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248398">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248404">1.4.1. <code class="varname">enable_stats</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248444">1.4.2. <code class="varname">min_se</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293415">1.4.3. <code class="varname">sst_interval</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293456">1.4.4. <code class="varname">reject_to_small</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293500">1.4.5. <code class="varname">sst_flag</code> (string/integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293556">1.5. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293561">1.5.1. 
		<code class="function">sstCheckMin(send_reply_flag)</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293620">1.6. Exported Statistics</a></span></dt><dd><dl><dt><span class="section"><a href="#id293625">1.6.1. <code class="varname">expired_sst</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248011">Session timer call flow</a></dt><dt>1.2. <a href="#id248427">Set <code class="varname">enable_stats</code> parameter</a></dt><dt>1.3. <a href="#id293399">Set <code class="varname">min_se</code> parameter</a></dt><dt>1.4. <a href="#id293440">Set <code class="varname">sst_interval</code> parameter</a></dt><dt>1.5. <a href="#id293484">Set <code class="varname">reject_to_small</code> parameter</a></dt><dt>1.6. <a href="#id293537">Set <code class="varname">sst_flag</code> parameter</a></dt><dt>1.7. <a href="#id293597"><code class="function">sstCheckMin</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248920"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249294"></a>1.1. Overview</h2></div></div></div><p>The sst module provides a way to update the
		dialog expire timer based on the SIP INVITE/200 OK
		Session-Expires header value. You can use the sst
		module in an OpenSIPS proxy to allow freeing of local
		resources of dead (expired) calls.</p><p>You can also use the sst module to validate the
		MIN_SE header value and reply to any request with a
		"422 - Session Timer Too Small" if the value is too
		small for your OpenSIPS configuration.</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248895"></a>1.2. How it works</h2></div></div></div><p>The sst module uses the dialog module to be notified of
	any new or updated dialogs. It will then look for and extract
	the session-expire: header value (if there is one) and
	override the dialog expire timer value for the current context
	dialog.</p><p>You flag any call setup INVITE that you want to cause a
	timed session to be established. This will cause OpenSIPS to
	request the use of session times if the UAC does not request
	it.</p><p>All of this happens with a properly configured dialog
	and sst module and setting the dialog flag and the sst flag at
	the time any INVITE sip message is seen. There is no
	opensips.cfg script function call required to set the dialog
	expire timeout value. See the dialog module users guide for
	more information.</p><p>The sstCheckMin() script function can be used to varify
	the Session-expires / MIN-SE header field values are not too
	small for a proxy. If the SST min_se parameter value is
	smaller then the messages Session-Expires / MIN-SE values, the
	test will return true. You can also configure the function to
	send the 422 response for you.</p><p>The following was taken from the RFC as a call flow
	example:</p><div class="example"><a name="id248011"></a><p class="title"><b>Example 1.1. Session timer call flow</b></p><div class="example-contents"><pre class="programlisting">
+-------+    +-------+       +-------+
| UAC-1 |    | PROXY |       | UAC-2 |
+-------+    +-------+       +-------+
    |(1) INVITE  |               |
    |SE: 50      |               |
    |-----------&gt;|               |
    |            |(2)sstCheckMin |
    |            |-----+         |
    |            |     |         |
    |            |&lt;----+         |
    |(3) 422     |               |
    |MSE:1800    |               |
    |&lt;-----------|               |
    |            |               |
    |(4)ACK      |               |
    |-----------&gt;|               |
    |            |               |
    |(5) INVITE  |               |
    |SE: 1800    |               |
    |MSE: 1800   |               |
    |-----------&gt;|               |
    |            |(6)sstCheckMin |
    |            |-----+         |
    |            |     |         |
    |            |&lt;----+         |
    |            |(7)setflag     |
    |            |Dialog flag    |
    |            |Set expire     |
    |            |-----+         |
    |            |     |         |
    |            |&lt;----+         |
    |            |               |
    |            |(8)INVITE      |
    |            |SE: 1800       |
    |            |MSE: 1800      |
    |            |--------------&gt;|
    |            |               |
 ...
     			</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248025"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248031"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>The following modules must be loaded
		before this module:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
		<span class="emphasis"><em>dialog</em></span> - dialog module and its decencies. (tm)
		</p></li><li><p>
			<span class="emphasis"><em>sl</em></span> - stateless module.
		</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248373"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
	The following libraries or applications must be installed before running
	OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>None</em></span>.
		</p></li></ul></div><p>
	</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248398"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248404"></a>1.4.1. <code class="varname">enable_stats</code> (integer)</h3></div></div></div><p>If the statistics support should be enabled or
		not. Via statistic variables, the module provide
		information about the dialog processing. Set it to zero to
		disable or to non-zero to enable it.</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">1</span>&#8221; (enabled).
		</em></span>
		</p><div class="example"><a name="id248427"></a><p class="title"><b>Example 1.2. Set <code class="varname">enable_stats</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sst", "enable_stats", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248444"></a>1.4.2. <code class="varname">min_se</code> (integer)</h3></div></div></div><p>The value is used to set the proxies MIN-SE
		value and is used in the 422 reply as the proxies
		MIN-SE: header value if the sstCheckMin() flag is set
		to true and the check fails.</p><p>If not set and sstCheckMin() is called with the
		send-reply flag set to true, the default 1800 seconds
		will be used as the compare and the MIN-SE: header
		value if the 422 reply is sent.</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">1800</span>&#8221; seconds.
		</em></span>
		</p><div class="example"><a name="id293399"></a><p class="title"><b>Example 1.3. Set <code class="varname">min_se</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sst", "min_se", 2400)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293415"></a>1.4.3. <code class="varname">sst_interval</code> (integer)</h3></div></div></div><p>The sst minimum interval in Session-Expires header if OpenSIPS
		request the use of session times. The used value will be the
		maximum value between OpenSIPS minSE, UAS minSE and this value.</p><p>Per default the interval used will be the min_se value</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">0</span>&#8221; seconds.
		</em></span>
		</p><div class="example"><a name="id293440"></a><p class="title"><b>Example 1.4. Set <code class="varname">sst_interval</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sst", "sst_interval", 2400)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293456"></a>1.4.4. <code class="varname">reject_to_small</code> (integer)</h3></div></div></div><p>In the initial INVITE if the UAC has requested a
		Session-Expire: and it's value is smaller then our
		local policies Min-SE (see min_se above), then the
		PROXY has the right to reject the call by replying to
		the message with a 422 Session Timer Too Small and
		state our local Min-SE: value. The INVITE is NOT
		forwarded on through the PROXY.</p><p>This flag if true will tell the SST module to
		reject the INVITE with a 422 response. If false, the
		INVITE is forwarded through the PROXY with out any
		modifications.</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">1</span>&#8221; (true/on).
		</em></span>
		</p><div class="example"><a name="id293484"></a><p class="title"><b>Example 1.5. Set <code class="varname">reject_to_small</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sst", "reject_to_small", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293500"></a>1.4.5. <code class="varname">sst_flag</code> (string/integer)</h3></div></div></div><p>Keeping with OpenSIPS, the module will not do
		anything to any message unless instructed to do so via
		the opensips.cfg script. You must set the sst_flag
		value in the setflag() call of the INVITE you want the
		sst module to process. But before you can do that, you
		need to tell the sst module which flag value you are
		assigning to sst.</p><p>In most cases when ever you create a new dialog
		via create_dialog() function,you will want to set the sst flag. 
		If create_dialog() is not called and the sst flag is set, 
		it will not have any effect.</p><p>This parameter must be set of the module will
		not load.</p><p><span class="emphasis"><em>WARNING: </em></span>Setting INT flags is deprecated!
		Use quoted strings instead!</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">Not set!</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293537"></a><p class="title"><b>Example 1.6. Set <code class="varname">sst_flag</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sst", "sst_flag", "SST_FLAG")
...
route {
  ...
  if (method=="INVITE") {
    setflag(SST_FLAG); # Set the sst flag
    create_dialog(); # and then create the dialog
  }
  ...
}
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293556"></a>1.5. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293561"></a>1.5.1. 
		<code class="function">sstCheckMin(send_reply_flag)</code>
		</h3></div></div></div><p>Check the current Session-Expires / MIN-SE values
		against the sst_min_se parameter value. If the
		Session-Expires or MIN_SE header value is less then
		modules minimum value, this function will return
		true. </p><p>If the fuction is called with the
		send_reply_flag set to true (1) and the requested
		Session-Expires / MIN-SE values are too small, a 422
		reply will be sent for you. The 422 will carry a
		MIN-SE: header with the sst min_se parameter value
		set.</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>min_allowed</em></span> - The value
			to compare the MIN_SE header value to.</p></li></ul></div><div class="example"><a name="id293597"></a><p class="title"><b>Example 1.7. <code class="function">sstCheckMin</code> usage</b></p><div class="example-contents"><pre class="programlisting">

...
modparam("sst", "sst_flag", 6)
modparam("sst", "min_se", 2400) # Must be &gt;= 90
...

route {
  if (method=="INVITE") {
	if (sstCheckMin("1")) {
		xlog("L_ERR", "422 Session Timer Too Small reply sent.\n");
		exit;
	}
	# track the session timers via the dialog module
	setflag(6);
	create_dialog();
  }
}

... or ...

route {
  if (method=="INVITE") {
	if (sstCheckMin("0")) {
		xlog("L_ERR", "Session Timer Too Small, dropping request\n");
		exit;
	}
	# track the session timers via the dialog module
	setflag(5);
	setflag(6);
  }
}
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293620"></a>1.6. Exported Statistics</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293625"></a>1.6.1. <code class="varname">expired_sst</code></h3></div></div></div><p>
		Number of dialogs which got expired session timer.
		</p></div></div></div></div></body></html>
