<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Stun Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249240"></a>Stun Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Pistolea</span></h3><code class="email">&lt;<a class="email" href="mailto:razvy000@yahoo.com">razvy000@yahoo.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Pistolea</span></h3><code class="email">&lt;<a class="email" href="mailto:razvy000@yahoo.com">razvy000@yahoo.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision:$</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id268058">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id271308">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id271631">1.1.1.  The idea</a></span></dt><dt><span class="section"><a href="#id248904">1.1.2.  Basic Operation</a></span></dt><dt><span class="section"><a href="#id249293">1.1.3.  Supported STUN Attributes </a></span></dt></dl></dd><dt><span class="section"><a href="#id248355">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248361">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248378">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248405">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248410">1.3.1. 
				<code class="varname">primary_ip</code> (str)
			</a></span></dt><dt><span class="section"><a href="#id248461">1.3.2. 
				<code class="varname">primary_port</code> (str)
			</a></span></dt><dt><span class="section"><a href="#id293434">1.3.3. 
				<code class="varname">alternate_ip</code> (str)
			</a></span></dt><dt><span class="section"><a href="#id293477">1.3.4. 
				<code class="varname">alternate_port</code> (str)
			</a></span></dt></dl></dd><dt><span class="section"><a href="#id293522">1.4. Exported MI Functions</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248438">Set
					<code class="varname">primary_ip</code> parameter
				</a></dt><dt>1.2. <a href="#id293417">Set <code class="varname">primary_port</code> parameter
				</a></dt><dt>1.3. <a href="#id293460">Set
					<code class="varname">alternate_ip</code> parameter
				</a></dt><dt>1.4. <a href="#id293504">Set
					<code class="varname">alternate_port</code> parameter
				</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id268058"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id271308"></a>1.1. Overview</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id271631"></a>1.1.1.  The idea</h3></div></div></div><p>
			A stun server working with the same port as SIP (5060) in order to
			gain accurate information. The benefit would be an exact external 
			address in the case of NATs translating differently when given 
			different destination ports. The server may also advertise different
			network addresses than the ones it is actually listening on.
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248904"></a>1.1.2.  Basic Operation</h3></div></div></div><p>
			The stun server will use 4 sockets:
			</p><div class="itemizedlist"><ul type="disc"><li>socket1 = ip1 : port1</li><li>socket2 = ip1 : port2</li><li>socket3 = ip2 : port1</li><li>socket4 = ip2 : port2</li></ul></div><p>
			</p><p>
				The sockets come from existing SIP sockets or are created.
			</p><p>
				Socket1 must allways be a SIP UDP listener from OpenSIPS.
			</p><p>
				The server will create a separate process.
				This process will listen for data on created sockets.
				The server will register a callback function to SIP.
				This function is called when a specific (stun)header is found.
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249293"></a>1.1.3.  Supported STUN Attributes </h3></div></div></div><p>
				This stun implements RFC3489 (and XOR_MAPPED_ADDRESS from 
				RFC5389)
			</p><p>
			</p><div class="itemizedlist"><ul type="disc"><li>MAPPED_ADDRESS</li><li>RESPONSE_ADDRESS</li><li>CHANGE_REQUEST</li><li>SOURCE_ADDRESS</li><li>CHANGED_ADDRESS</li><li>ERROR_CODE</li><li>UNKNOWN_ATTRIBUTES</li><li>REFLECTED_FROM</li><li>XOR_MAPPED_ADDRESS</li></ul></div><p>
			</p><p> Not supported attributes:</p><p>
			</p><div class="itemizedlist"><ul type="disc"><li>USERNAME</li><li>PASSWORD</li><li>MESSAGE_INTEGRITY</li></ul></div><p>
			and associated ERROR_CODEs
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248355"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248361"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
			The following modules must be loaded before this module:
			</p><p>
			<span class="emphasis"><em>None</em></span>.
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248378"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
			The following libraries or applications must be installed before 
			running OpenSIPS with this module loaded:
				</p><div class="itemizedlist"><ul type="disc"><li><p>
							<span class="emphasis"><em>None</em></span>.
						</p></li></ul></div><p>
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248405"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248410"></a>1.3.1. 
				<code class="varname">primary_ip</code> (str)
			</h3></div></div></div><p>
			The IP of an interface which is configured as an UDP SIP listener
			in OpenSIPS. This is a mandatory parameter. 
			</p><p>
			Syntax: "ip [/ advertised_ip]
			</p><p>
			By default, the <span class="emphasis"><em>primary_ip</em></span> and the advertised
			<span class="emphasis"><em>primary_ip</em></span> will be identical.
			This may be changed with an optional "/ xxx.xxx.xxx.xxx" string.
			</p><div class="example"><a name="id248438"></a><p class="title"><b>Example 1.1. Set
					<code class="varname">primary_ip</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun", "primary_ip", "192.168.0.100")

# Example of a STUN server within OpenSIPS which is behind NAT
modparam("stun", "primary_ip", "192.168.0.100 / 64.50.46.78")
...
				</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248461"></a>1.3.2. 
				<code class="varname">primary_port</code> (str)
			</h3></div></div></div><p>
			The port configured (together with the <span class="emphasis"><em>primary_ip</em></span>) as an UDP SIP
			listener in OpenSIPS. The default value is 5060.
			</p><p>
			Syntax: "port [/ advertised_port]
			</p><p>
			By default, the <span class="emphasis"><em>primary_port</em></span> and the advertised
			<span class="emphasis"><em>primary_port</em></span> will be identical.
			This may be changed with an optional "/ adv_port" string.
			</p><div class="example"><a name="id293417"></a><p class="title"><b>Example 1.2. Set <code class="varname">primary_port</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun", "primary_port", "5060")

# Listening on a primary port, but advertising a different one
modparam("stun", "primary_port", "5060 / 5062")
...
				</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293434"></a>1.3.3. 
				<code class="varname">alternate_ip</code> (str)
			</h3></div></div></div><p>
			Another IP from another interface. This is a mandatory parameter.
			</p><p>
			Syntax: "ip [/ advertised_ip]
			</p><p>
			By default, the <span class="emphasis"><em>alternate_ip</em></span> and the advertised
			<span class="emphasis"><em>alternate_ip</em></span> will be identical.
			This may be changed with an optional "/ xxx.xxx.xxx.xxx" string.
			</p><div class="example"><a name="id293460"></a><p class="title"><b>Example 1.3. Set
					<code class="varname">alternate_ip</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun","alternate_ip","11.22.33.44")

# Example of a STUN server within OpenSIPS which is behind NAT
modparam("stun", "alternate_ip", "192.168.0.100 / 64.78.46.50")
...
				</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293477"></a>1.3.4. 
				<code class="varname">alternate_port</code> (str)
			</h3></div></div></div><p>
			The port used by the STUN server for the second interface.
			The default value is 3478 (default STUN port).
			</p><p>
			Syntax: "port [/ advertised_port]
			</p><p>
			By default, the <span class="emphasis"><em>alternate_port</em></span> and the advertised
			<span class="emphasis"><em>alternate_port</em></span> will be identical.
			This may be changed with an optional "/ adv_port" string.
			</p><div class="example"><a name="id293504"></a><p class="title"><b>Example 1.4. Set
					<code class="varname">alternate_port</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun","alternate_port","3479")

# Listening on an alternate port, but advertising a different one
modparam("stun", "alternate_port", "5060 / 5062")
...
				</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293522"></a>1.4. Exported MI Functions</h2></div></div></div></div></div></div></body></html>
